<template>
    <v-navigation-drawer
        v-model="drawer"
        absolute
        class="grey darken-3"
        dark
    >
        <v-list>
            <v-list-tile>
                <v-list-tile-action>
                    <v-icon>home</v-icon>
                </v-list-tile-action>
                <v-list-tile-title>Dashboard</v-list-tile-title>
            </v-list-tile>
            <v-list-group v-for="item in menuItems"
                          :key="item.name"
                          :prepend-icon="item.icon"
                          :value="item.is_open"
            >
                <template v-slot:activator>
                    <v-list-tile>
                        <v-list-tile-title>{{item.name}}</v-list-tile-title>
                    </v-list-tile>
                </template>
                <v-list-tile
                    v-for="(child, i) in item.child"
                    :key="i"
                    @click="menuItemClickHandler(child.name)"
                >
                    <v-list-tile-action>
                        <v-icon v-text="child.icon"></v-icon>
                    </v-list-tile-action>
                    <v-list-tile-title v-text="child.name"></v-list-tile-title>
                </v-list-tile>
            </v-list-group>
        </v-list>
    </v-navigation-drawer>
</template>

<script>
    export default {
        name: "LeftSidebar",
        data: () => ({
            drawer: true,
            menuItems: [],
            admins: [
                ['Management', 'people_outline'],
                ['Settings', 'settings']
            ],
            cruds: [
                ['Create', 'add'],
                ['Read', 'insert_drive_file'],
                ['Update', 'update'],
                ['Delete', 'delete']
            ]
        }),
        created() {
            axios.get('/panel/user-roles')
                .then(response => {
                    let roles = response.data;
                    let routes = this.$router.options.routes;
                    for (let route in routes) {
                        if (routes[route].menu && !routes[route].hasOwnProperty('parent')) {
                            let name = routes[route].name;
                            let childItems = this.findChildItems(name, roles);
                            for (let role in routes[route].access) {
                                if (!roles.includes(routes[route].access[role])) {
                                    continue;
                                }
                                this.menuItems.push({
                                    child: childItems.items,
                                    path: routes[route].path,
                                    icon: routes[route].icon,
                                    name: this.ucFirst(name),
                                    is_active: this.isCurrentRoute(routes[route].path),
                                    is_open: this.isCurrentRoute(routes[route].path) || childItems.hasCurrent
                                });
                                break;
                            }


                        }
                    }
                })
                .catch(error => {
                    alert(error);
                    console.log(error);
                });

        },
        methods: {

            findChildItems(name, roles) {
                let childItems = [];
                let hasCurrent = false;
                let routes = this.$router.options.routes;
                for (let route in routes) {
                    if (!routes[route].menu) {
                        continue;
                    }
                    if (!routes[route].hasOwnProperty('parent')) {
                        continue;
                    }

                    if (routes[route].parent === name) {
                        let routeItem = routes[route];
                        if (this.isCurrentRoute(routeItem.path)) {
                            hasCurrent = true;
                        }
                        for (let role in routes[route].access) {
                            if (!roles.includes(routes[route].access[role])) {
                                continue;
                            }
                            childItems.push({
                                path: routeItem.path,
                                name: this.ucFirst(routeItem.name),
                                icon: routeItem.icon,
                                is_active: this.isCurrentRoute(routeItem.path)
                            });
                            break;
                        }
                    }
                }
                return {
                    items: childItems,
                    hasCurrent: hasCurrent
                };
            },
            isCurrentRoute(path) {
                let regex = new RegExp(path.replace(/\//g, '\\/') + '(\\/|$)');

                if (regex.exec(this.$route.path) !== null) {
                    return true;
                }
                return false;
            },
            ucFirst(string) {
                return string.charAt(0).toUpperCase() + string.slice(1);
            },
            menuItemClickHandler(routeName) {
                this.$router.push({name: routeName.toLowerCase()})
            }
        }
    }
</script>

<style scoped>

</style>
